///////////////////////////////////////////////////////////////////////////////////
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;
///////////////////////////////////////////////////////////////////////////////////
#define NOISENTEX "tx/NoiseN3.png"
#define ScnScale 1.0
static float LTLength=3.0;//4.0
static float LSZScale=1.0;
float time : TIME;
#define SAMPNUMSSAO 2
#define SAMPNUM 8


#define SAMPNUMSSS2 4

#define SAMPNUMSSAO2 16

#define SAMPNUMS2 4

#define SAMPNUMSS2 4


static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
//e

float3 SkyColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = ""; >;
float3 GroundColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "nʊ"; >;
float EnvDefColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "0"; >;
float EnvAllColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "S0"; >;
float SRainRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "J"; >;

float CloudRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "_"; >;
float CloudSpeedRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "_x"; >;
static float CloudTime=(CloudSpeedRate-0.5)*time*0.1;

static float3 SkyColor=(0.05*(1.0-EnvDefColor0)+SkyColor1)*LightColor*(1.0-EnvAllColor0);
static float3 GroundColor=(0.05*(1.0-EnvDefColor0)+GroundColor1)*LightColor*(1.0-EnvAllColor0);

float Si10 : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Rx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;
float Ry : CONTROLOBJECT < string name = "(self)"; string item = "Ry"; >;
float Rz : CONTROLOBJECT < string name = "(self)"; string item = "Rz"; >;
float Z : CONTROLOBJECT < string name = "(self)"; string item = "Z"; >;
//static float LSGIScale = Si10*0.1;
static float SSAORate=(1.0+Rx*180/3.14);
static float CanselRate=0.0+Ry*180/3.14;
static float SSAODirRate=Z;
//static float SSRRate=1.0+Rz*180/3.14;




///////////////////////////////////////////////////////////////////////////////////
float4x4 SMat: CONTROLOBJECT < string name = "MainSystem.x"; >;
static float3 SPos = float3(SMat._41, SMat._42, SMat._43);
float ShSi2 : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Si"; >;

static float ShSi = ShSi2*0.1;

float SoftShadowRate : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Tr"; >;


float3    LightDirL1   : DIRECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;

static float3 PosL = SPos  - LightDirection * 3000;


float4 GetLightPos(float3 WPos)
{

	float LYZFlag = step(0.999, pow(LightDirection.y, 2));

	float3 LCrossX = normalize(cross(LightDirection, float3(0.0, LYZFlag, 1.0 - LYZFlag)));

	float3 LCrossY = normalize(cross(LightDirection, LCrossX));

	float4 XYZ = 0;

	float3 WLL=(WPos - PosL);
	XYZ.z = dot(LightDirection, WLL);
	XYZ.x = dot(LCrossX, WLL);
	XYZ.y = dot(LCrossY, WLL);

	XYZ.xy /= 256 * ShSi;


	XYZ.z = (XYZ.z - 500) / (6000 - 500);


	XYZ.w = 1;
	return XYZ;
}



shared texture KrSSLiteShaMapRT: OFFSCREENRENDERTARGET <
	string Description = "LS";
	int Width =4096;
	int Height =4096;
	string Format = "R32F";
	float4 ClearColor = { 100000, 0, 0, 0 };
	float ClearDepth = 1.0;
	bool AntiAlias = false;//true;
	int Miplevels = 1;
	string DefaultEffect =
		"self = hide;"
		"* = ShadowMap/ShadowMap.fx;";
>;
sampler2D KrSSLiteShaSamp = sampler_state {
	texture = <KrSSLiteShaMapRT>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
static float2 SSampStep =0.25 / 4096;

///////////////////////////////////////////////////////////////////////////////////
//e܂1



float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 ViewMatrix      : VIEW;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(1, 1) / ViewportSize);
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 2560;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);



shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET ;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



shared texture2D WPosKrMap : RENDERCOLORTARGET ;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D AlbedoMap : RENDERCOLORTARGET ;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET ;
sampler2D MatASamp = sampler_state {
	texture = <MatAMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D LumiMap : RENDERCOLORTARGET ;

shared texture2D PLDiffuseMap : RENDERCOLORTARGET;
sampler2D PLDiffuseSamp = sampler_state {
	texture = <PLDiffuseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D SSAOMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
int MipLevels = 1;
string Format = "R16F";
>;
sampler2D SSAOSamp = sampler_state {
	texture = <SSAOMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



texture2D DirShadowAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowASamp = sampler_state {
	texture = <DirShadowAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D DirShadowBMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
bool AntiAlias = false;
string Format = "R16F";
float4 ClearColor = { 0, 0, 0, 0 };
>;
sampler2D DirShadowBSamp = sampler_state {
	texture = <DirShadowBMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D PLSpecularMap : RENDERCOLORTARGET;
sampler2D PLSpecularSamp = sampler_state {
	texture = <PLSpecularMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

texture2D DiffuseMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D DiffuseSamp = sampler_state {
	texture = <DiffuseMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D SSSMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SSSSamp = sampler_state {
	texture = <SSSMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = MIRROR;
	AddressV = MIRROR;
};


texture2D SpecularMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D SpecularSamp = sampler_state {
	texture = <SpecularMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


shared texture2D TotalKrSSLMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D TotalKrSSLSamp = sampler_state {
	texture = <TotalKrSSLMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
	string Format = "D24S8";
>;

texture2D NoiseNMap <
	string ResourceName = NOISENTEX;
	int MipLevels = 0;
>;
sampler NoiseNSamp = sampler_state {
	texture = <NoiseNMap>;
    MINFILTER = NONE;
    MAGFILTER = NONE;
    MIPFILTER = NONE;
	AddressU = WRAP;
	AddressV = WRAP;
};

texture2D CloudMap <
	string ResourceName = "tx/Noise4.png";
	int MipLevels = 0;
>;
sampler CloudSamp = sampler_state {
	texture = <CloudMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};

float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View);
  float3 dp2 = ddy(View);
  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = mul(float2(duv1.x, duv2.x), inverseM);
  float3 Binormal = mul(float2(duv1.y, duv2.y), inverseM);

  return float3x3(normalize(Tangent), normalize(Binormal), Normal);
}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}
float GetDORate(float3 Normal, float2 Tex, float2 TexAdd, float3 WPos, float StartAddScale)
{
	float Rate = 0;
	float2 STex = Tex - TexAdd*StartAddScale;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSAO2; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos.xyz - WPos.xyz);


		float VG = saturate(1.0-distance(normalize(Gap), Normal.xyz)*2);

		Rate += VG;
	}
	Rate = saturate(Rate/SAMPNUMSSAO2*16);
	//Rate = saturate(Rate);
	return Rate;
}
float GetAORate2(float3 BaseNormal,float3 EyeVec, float2 Tex, float3 WPos, float StartAddScale,float3 Noise1)
{
	float Rate = 0;
	
	float3x3 tangentFrame = compute_tangent_frame(BaseNormal, EyeVec, Tex);
	float3 Normal = normalize(lerp(BaseNormal,normalize(mul(normalize(2.0f * saturate(Noise1.rgb) - 1.0f), tangentFrame)),StartAddScale*0.5+0.5));

	float SSAONScale=0.03;
	float3 SSAOPos = WPos.xyz + Normal.xyz;
	float4 SSAOTex = mul(float4(SSAOPos, 1.0), ViewProjMatrix);
	SSAOTex.x = (1.0f + SSAOTex.x / SSAOTex.w) * 0.5f;
	SSAOTex.y = (1.0f - SSAOTex.y / SSAOTex.w) * 0.5f;
	float2 TexAdd =normalize(SSAOTex.xy - Tex.xy)*SSAONScale;

	float2 STex = Tex - TexAdd*StartAddScale;
	float VGS=0;
	[unroll]
	for (int R = 1; R <= SAMPNUMSSAO; R += 1) {

		STex += TexAdd;
		float4 AOWPos = tex2D(WPosSamp, STex.xy);
		float3 Gap=(AOWPos - WPos.xyz);
		float VG = max(0.0,(dot(normalize(Gap),BaseNormal))/(1.0+length(Gap)*0.001));
		//VGS=max(VGS,VG);
		Rate+=VG;
	}
	//Rate=VGS;
	Rate = saturate(Rate/ SAMPNUMSSAO);
	
	return Rate;
}

float4 PS_SSAOA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=1.0;
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	


	


	float NoiseTexScale=64;
	float3 Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale);
	float GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0, Noise1);
	float GIAORate0 =GIAORate1;


	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.1,0.1));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.1, Noise1);
	GIAORate0 += GIAORate1;	
	
	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.2,0.2));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.2, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.3,0.3));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.3, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.4,0.4));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.4, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.5,0.5));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.5, Noise1);
	GIAORate0 += GIAORate1;	
	
	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.6,0.6));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.6, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.7,0.7));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.7, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.8,0.8));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.8, Noise1);
	GIAORate0 += GIAORate1;

	Noise1 =tex2D(NoiseNSamp,Tex*ViewportSize.xy/NoiseTexScale+float2(0.9,0.9));
	GIAORate1 = GetAORate2(Normal,EyeVec, Tex, WPos, 0.9, Noise1);
	GIAORate0 += GIAORate1;
	GIAORate0/=10;
	GIAORate0*=1.2;
	float GIAORate =  saturate(1.0 - saturate(GIAORate0-CanselRate)*SSAORate);


	//Color.rgb = GIAORate;
	Color.rgb = lerp(GIAORate,1.0,step(tex2D(MaterialKrSSLSamp,Tex).a,0.0));

	return Color;

}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(NormalDepthSamp, Tex-ViewportOffset);
	float4 WPos = tex2D(WPosSamp, Tex-ViewportOffset);
	WPos.a = 1.0;
	float3 Normal = ND.rgb;
	float Depth = ND.a;
	float4 Color = 1.0;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);

	float3 MatKrSSL=tex2D(MaterialKrSSLSamp,Tex);
	float3 Mat2 = fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	float RFlag=step(1.5,Mat2.y)*step(Mat2.y,3.5);
	float RFlag2=RFlag*saturate(pow(dot(LightDir,-Normal),2)+(max(0.0,dot(LightDir,-EyeVec))*0.13));
	float3 Normal2=normalize(lerp(Normal,LightDir,RFlag2*0.5));
	

	Color.r = saturate((dot(LightDir, Normal2)) * 80);
	float4 ZCalcTex= GetLightPos(WPos.xyz);

	// eNX`Wɕϊ
	ZCalcTex /= ZCalcTex.w;
	float ZTexLength=length(ZCalcTex.xy);
	float2 TransTexCoord;
	TransTexCoord.x = (1.0f + ZCalcTex.x)*0.5f;
	TransTexCoord.y = (1.0f - ZCalcTex.y)*0.5f;
	//TransTexCoord.x += 0.5/4096;
	//TransTexCoord.y -= 0.5/4096;

	
	//float SCor =length(scaleProj)+min(5.0, Depth*0.002)+2.0;
	//float SCorS =10000.0/(1.0+ShSi*0.2);

	float SCor =2.0+saturate(Depth*0.01-2);
	float SCorS =8000.0/(1.0+ShSi*0.2);

	float SSRate = saturate(max(ZCalcTex.z - tex2D(KrSSLiteShaSamp, TransTexCoord).r, 0.0f) *SCorS - SCor);
	float2 SSampStep2=SSampStep*SoftShadowRate*2;
	
	
	[unroll]
	for (int ix =-SAMPNUMS2; ix <= SAMPNUMS2; ix++) {
	for (int iy = -SAMPNUMS2; iy <= SAMPNUMS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = TransTexCoord+ SSampStep2*AddTexB;
	
		float SColor= tex2D(KrSSLiteShaSamp, Stex).r;
		SSRate+=saturate(max(ZCalcTex.z - SColor, 0.0f)*SCorS - SCor);

	}
	}
	
	SSRate = 1.0 - saturate(SSRate / pow(SAMPNUMS2*2 + 1,2)*4);

	float TexFlag=saturate(pow((length(TransTexCoord.xy-0.5))*2,2)-0.75)*4;

	Color.r *=  saturate(SSRate+TexFlag);


	float LSSize=0.02;//(0.02 + max(0.0,Depth*0.002 - 0.5));
	float3 L2Normal = normalize(lerp(-LightDirection, Normal , 0.0));
	float3 DOPos = WPos.xyz + L2Normal;
	float4 DOTex = mul(float4(DOPos, 1.0), ViewProjMatrix);
	DOTex.x = (1.0f + DOTex.x / DOTex.w) * 0.5f;
	DOTex.y = (1.0f - DOTex.y / DOTex.w) * 0.5f;
	float2 DOTexAdd =(DOTex.xy - Tex.xy)*LSSize;
	float SRate = GetDORate(L2Normal, Tex, DOTexAdd, WPos, 0.0);


	Color.r*=saturate(1.0-SRate+RFlag2);//*(1.0-RFlag2);

	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_DirShadowB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	
	float2 STexSampA = SampStep * ViewportSize.y/1080*(0.5+dot(EyeVec,Normal))*SoftShadowRate;///min(10,max(1.0,Depth*0.1));
	float2 stexAdd = 0;
	float FColor = tex2D(DirShadowASamp, Tex).r;
	float VGT = 1.0;
	
	[unroll]
	for (int ix =-SAMPNUMSS2; ix <= SAMPNUMSS2; ix++) {
	for (int iy = -SAMPNUMSS2; iy <= SAMPNUMSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;
		
		float4 AONormal = tex2D(NormalDepthSamp, Stex);
		float VG =saturate(1.0-distance(AONormal.xyz, Normal.xyz));

		VG *=saturate(1.0-distance(AONormal.xyz, Normal.xyz)*4);
		VG *=saturate(1.0-distance(AONormal.a, Depth)*10);







		float SColor2 = tex2D(DirShadowASamp, Stex).r;
		FColor += SColor2*VG;
		VGT += VG;
	}
	}
	FColor /=max(1.0,VGT);	
	Color.r=saturate(FColor);





	return Color;
}



////////////////////////////////////////////////////////////////////////////////////////////////

/*
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float A = 1 - 0.5*(RoughnessA / (RoughnessA + 0.33));
	float B = 0.45*(RoughnessA / (RoughnessA + 0.09));

	float dotEN = saturate(dot(EyeVec, Normal));
	float dotLN = saturate(dot(LightDir, Normal));

	float alpha = max(acos(dotEN), acos(dotLN));
	float beta = min(acos(dotEN), acos(dotLN));

	float D = sin(alpha) * tan(beta);

	float gamma = dot(normalize(EyeVec - Normal * dotEN), normalize(LightDir - Normal * dotLN));
	float C = max(0, gamma);
	//float4  OrNer = max(0.0f, dot(Normal, l)) * (A + B * C * D);

	float Diffuse = dotLN *(A + B * C * D);
	return Diffuse;
}
*/
float GetDif(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA)
{
	float dotLN = saturate(dot(LightDir, Normal));
	float Diffuse = dotLN;
	return Diffuse;
}


float4 PS_Diffuse(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=RMSS.b;
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////
	
	float3 MatKrSSL=tex2D(MaterialKrSSLSamp,Tex);
	float3 Mat2 = fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	float RFlag=step(1.5,Mat2.y)*step(Mat2.y,3.5);
	float RFlag2=RFlag*saturate(pow(dot(LightDir,-Normal),2)+(max(0.0,dot(LightDir,-EyeVec))*0.13));
	Normal=normalize(lerp(Normal,LightDir,RFlag2));


	float SSAORateB=tex2D(SSAOSamp,Tex);

	float DiffuseRate=GetDif(Normal, LightDir, EyeVec, RoughnessA);
	float Dif=DiffuseRate*ShadowRate.r;
	float3 EnvColor=SkyColor*saturate(dot(normalize(LightDir*0.3+float3(0.0,1.0,0.0)),Normal)*0.5+0.5)+GroundColor*saturate(dot(normalize(-LightDir*0.3+float3(0.0,-1.0,0.0)),Normal)*0.5+0.5);

	float3 CloudColor=lerp(1.0,pow(tex2D(CloudSamp,WPos.xz*0.0004+CloudTime),1.0/2),CloudRate);

	float3 TotalDiffuseColor=Dif*LightColor/ 3.141592*lerp(1.0,SSAORateB,SSAODirRate);
	
	TotalDiffuseColor+=EnvColor*SSAORateB;

	TotalDiffuseColor*=CloudColor;

	TotalDiffuseColor+=tex2D(PLDiffuseSamp,Tex);

	//Toonp
	//float3 DiffuseToon=TotalDiffuseColor.rgb;
	//DiffuseToon=(min(1.5,round(length(DiffuseToon)*0.7)+0.4))*normalize(DiffuseToon);

	//float3 DiffuseToon=TotalDiffuseColor.rgb;
	//DiffuseToon=(round(length(DiffuseToon))*0.5+0.5)*normalize(DiffuseToon);
	//TotalDiffuseColor=DiffuseToon;

	Color.rgb=TotalDiffuseColor;
	
	
	return Color;
}




float4 PS_SSS(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =1.0;
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=RMSS.r;
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float Specular=RMSS.b;
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 SSSCircle=normalize(pow(Albedo.rgb,8));
	float3 SSSColor=normalize(pow(Albedo.rgb,8));
	float SSSRate= RMSS.a;

	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////

	
	
	float3 TotalDiffuse=tex2D(DiffuseSamp, Tex);
	float3 TotalDiffuseSSS=TotalDiffuse;
	float2 SSSSampStep = SampStep2 / max(1.0, min(100.0, Depth*scaleProj))*60;
	
	
	
	float SSSRateS = 0.0;
	float2 STexSampA =SSSSampStep*SSSCircle.r;
	float TotalDiffuseSSS1 = 0;
	float SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).r;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*16,2));
		TotalDiffuseSSS.r += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.r=lerp(TotalDiffuse.r,TotalDiffuseSSS.r / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.g;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).g;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*16,2));
		TotalDiffuseSSS.g += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.g=lerp(TotalDiffuse.g,TotalDiffuseSSS.g / SSSRateS,step(0.00001,SSSRateS));
	
	
	SSSRateS = 0.0;
	STexSampA =SSSSampStep*SSSCircle.b;
	TotalDiffuseSSS1 = 0;
	SSSRateS1 = 0;
	
	[unroll]
	for (int ix =-SAMPNUMSSS2; ix <= SAMPNUMSSS2; ix++) {
	for (int iy = -SAMPNUMSSS2; iy <= SAMPNUMSSS2; iy++) {
		float2 AddTexB = float2(ix,iy);
		float2 Stex = Tex+ STexSampA*AddTexB;

		float4 GIND = tex2D(NormalDepthSamp, Stex);
		
		TotalDiffuseSSS1 = tex2D(DiffuseSamp, Stex).b;
		float SSSRateS1 = tex2D(MatASamp, Stex).a;
		 SSSRateS1*=saturate(1.0-pow((GIND.a-ND.a)*16,2));
		TotalDiffuseSSS.b += TotalDiffuseSSS1*SSSRateS1;
		SSSRateS += SSSRateS1;
		
	}
	}
	TotalDiffuseSSS.b=lerp(TotalDiffuse.b,TotalDiffuseSSS.b / SSSRateS,step(0.00001,SSSRateS));
	
	

	TotalDiffuse = lerp(TotalDiffuse, TotalDiffuseSSS, saturate(SSSRate*SSSColor));
	
	
	Color.rgb =TotalDiffuse*(1.0-Metalic)*Albedo.rgb;

	float3 MatKrSSL=tex2D(MaterialKrSSLSamp,Tex);
	float3 Mat2 = fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	float PlaneFlag=step(0.5,Mat2.y)*step(Mat2.y,1.5);

	Color.rgb = lerp(Color.rgb, Albedo.rgb,PlaneFlag);
	
	return Color;
}


float GetSp(float3 Normal, float3 LightDir, float3 EyeVec, float RoughnessA, float F0)
{
	float3 HalfVec = normalize(EyeVec + LightDir);
	float DotNL = max(0.00000001, saturate(dot(Normal, LightDir)));
	float DotNE = max(0.00000001, saturate(dot(Normal, EyeVec)));
	float DotNH = max(0.00000001, saturate(dot(Normal, HalfVec)));
	float DotEH = max(0.00000001, saturate(dot(EyeVec, HalfVec)));
	float DotLH = max(0.00000001, saturate(dot(LightDir, HalfVec)));

	float D = pow(RoughnessA, 2) / (3.14159265*pow(pow(DotNH, 2)*(pow(RoughnessA, 2) - 1) + 1, 2));
	float F = F0 + (1 - F0)*pow(1.0 - DotEH, 5);
	float G = min(1.0, min(2 * DotNH*DotNE / DotEH, 2 * DotNH*DotNL / DotEH));
	float Specular = F*D*G / (4 * DotNE*DotNL);// +0.0001);

	Specular = max(0.0, min(2.0, Specular));

	return Specular;
}




float4 PS_Specular(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SSSSamp,Tex);
	////////////////////////////////////////////////////////////////////////////////////
	float4 RMSS=tex2D(MatASamp,Tex);//Roughness/Metalic/Specular/SSS
	float Roughness=lerp(RMSS.r,0.2,SRainRate);
	float RoughnessA=pow(Roughness,2);
	float Metalic=RMSS.g;
	float F0 = lerp(F0Def, F0MetalDef, saturate(Metalic+(1.0-Roughness)*0.05));
	float Specular=lerp(RMSS.b,1.0,SRainRate);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	float3 WPos = tex2D(WPosSamp, Tex).xyz;
	float4 ND = tex2D(NormalDepthSamp, Tex);
	float Depth = ND.a;
	float3 Normal = ND.xyz;
	float3 EyeVec = -normalize(WPos.xyz - CameraPosition);
	float ShadowRate=tex2D(DirShadowBSamp,Tex).r;
	////////////////////////////////////////////////////////////////////////////////////
	
	
	
	float3 SpecularAlbedo = lerp(Specular, Albedo.rgb, saturate(Metalic));
	
	float3 SpecularColor =  GetSp(Normal, LightDir, EyeVec, RoughnessA, F0)*LightColor* SpecularAlbedo*ShadowRate.r;

	//float3 EnvColor=SkyColor*GetSp(Normal, normalize(LightDir-Normal*4+float3(0.0,1.5,0.0)), EyeVec, RoughnessA, F0);
	//EnvColor+=GroundColor*GetSp(Normal, normalize(-LightDir-Normal*2+float3(0.0,-1.5,0.0)), EyeVec, RoughnessA, F0);
	//EnvColor*=SpecularAlbedo*0.1;
	//SpecularColor+=EnvColor;

	SpecularColor+=tex2D(PLSpecularSamp,Tex)* SpecularAlbedo;


	
	
	float ENDotR=max(0.0,2.0-dot(EyeVec,ND.xyz));
	


	
	//Color.rgb=SpecularColor;
	float SSAORateB=tex2D(SSAOSamp,Tex);
	Color.rgb=SpecularColor*SSAORateB;
	return Color;
}

float4 PS_TotalKrSSL(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color =tex2D(SpecularSamp,Tex);
	float4 Albedo=tex2D(AlbedoSamp,Tex);
	Albedo.rgb = pow(Albedo.rgb, 2.2);
	Color.rgb +=tex2D(SSSSamp,Tex);
	float3 MatKrSSL=tex2D(MaterialKrSSLSamp,Tex);
	float3 Mat2 = fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	float PlaneFlag=step(0.5,Mat2.y)*step(Mat2.y,1.5);

	Color.rgb = lerp(Color.rgb, Albedo.rgb,PlaneFlag);



	//Color.rgb=tex2D(SSAOSamp,Tex).r*0.5;

	Color.rgb = pow(Color.rgb, 1.0/2.2);

	//Color.rgb=tex2D(SSAOSamp,Tex).r*0.5;


	//float RFlag=step(1.5,Mat2.y)*step(Mat2.y,3.5);
	//Color.rgb =RFlag;
	Color.rgb = min(5.0,max(0.0,Color.rgb));
	return Color;
}



technique FILTER <
	string Script =

	"RenderColorTarget0=SSAOMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSAOA;"

	"RenderColorTarget0=DirShadowAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowA;"
	
	"RenderColorTarget0=DirShadowBMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=DirShadowB;"



	"RenderColorTarget0=DiffuseMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Diffuse;"

	"RenderColorTarget0=SSSMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=SSS;"




	"RenderColorTarget0=SpecularMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Specular;"
	
	"RenderColorTarget0=TotalKrSSLMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=TotalKrSSL;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ScriptExternal=Color;"

	;

> {
	pass SSAOA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSAOA();
	}
	pass DirShadowA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowA();
	}
	pass DirShadowB < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_DirShadowB();
	}

	pass Diffuse < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Diffuse();
	}
	pass SSS < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_SSS();
	}

	pass Specular < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Specular();
	}
	pass TotalKrSSL < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_TotalKrSSL();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
